
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Oracle Logminer 日志挖掘 / iVAN</title>

    <meta name="description" content="Oracle Logminer 日志挖掘 生产环境中考虑到数据库的性能问题,很少会打开数据的审计功能,应用层也不会记录SQL的执行信息:但是生产上经常会遇到某张表的某几条被修改掉,但是应用又查不到是哪个接口修改的记录,这时候Logminer 就派上用场了. Logminer 8i之后的一款免费日志分析工具:通过分析在线日志文件或者归档日志文件,返回数据库DDL/DML操作语句.执行时间.用户等等可以追查的信息,快速定位问题. 使用Logminer 工具,数据库需要开启强制日志和归档模式 数据库配置 # 开启强制日志模式 # 查看当前数据">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Oracle Logminer 日志挖掘</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h5>生产环境中考虑到数据库的性能问题，很少会打开数据的审计功能，应用层也不会记录SQL的执行信息；但是生产上经常会遇到某张表的某几条被修改掉，但是应用又查不到是哪个接口修改的记录，这时候Logminer 就派上用场了。</h5>
<h5>Logminer 8i之后的一款免费日志分析工具：通过分析在线日志文件或者归档日志文件，返回数据库DDL/DML操作语句、执行时间、用户等等可以追查的信息，快速定位问题。</h5>
<h5>使用Logminer 工具，数据库需要开启强制日志和归档模式</h5>
<h5>数据库配置</h5>
<pre><code># 开启强制日志模式

# 查看当前数据库日志模式
SQL&gt; SELECT supplemental_log_data_min, force_logging FROM v$database;

# 如果返回结果为NO，则
SQL&gt; ALTER DATABASE ADD SUPPLEMENTAL LOG DATA;
SQL&gt; ALTER DATABASE FORCE LOGGING;

# 确认是否已经修改，输出为YES
SQL&gt; SELECT supplemental_log_data_min, force_logging FROM v$database;

# 切换系统日志
SQL&gt; ALTER SYSTEM SWITCH LOGFILE;

# 数据库处于归档模式
SQL&gt; archive log list
Database log mode          Archive Mode
Automatic archival         Enabled
Archive destination        USE_DB_RECOVERY_FILE_DEST
Oldest online log sequence     107
Next log sequence to archive   109
Current log sequence           109
# 默认归档日志路径
SQL&gt; show parameter db_recover

NAME                     TYPE    VALUE
------------------------------------ ----------- ------------------------------
db_recovery_file_dest            string  /u01/app/oracle/fast_recovery_area
db_recovery_file_dest_size       big integer 4977M
# 若数据库处于非归档模式，则需要
# 干净的关闭掉数据库
SQL&gt; shutdown immediate
# 打开至mount状态
SQL&gt; startup mount
# 设置为归档模式
SQL&gt; alter database archivelog;
# 开启数据库
SQL&gt; alter database open;
</code></pre>
<h5>Logminer 配置</h5>
<pre><code># 首先安装 logminer 使用到的包，将创建用于分析的过程和视图
SQL&gt; @$ORACLE_HOME/rdbms/admin/dbmslm.sql
SQL&gt; @$ORACLE_HOME/rdbms/admin/dbmslmd.sql

# 参数配置，用于创建字典文件
SQL&gt; show parameter utl

NAME                     TYPE    VALUE
------------------------------------ ----------- ------------------------------
utl_file_dir                 string  /u01/app/oracle/logminer
# 如果VALUE 为 NULL，那么需要在线修改并重启实例生效
SQL&gt; alter system set utl_file_dir='/u01/app/oracle/logminer' scope=spfile;

#  创建字典文件
SQL&gt; CREATE DIRECTORY utlfile AS '/u01/app/oracle/logminer';

SQL&gt; EXECUTE dbms_logmnr_d.build(dictionary_filename =&gt; 'dictionary.ora', dictionary_location =&gt;'/u01/app/oracle/logminer');

SQL&gt; !ls  /u01/app/oracle/logminer
dictionary.ora
</code></pre>
<h5>对测试数据表进行操作</h5>
<pre><code>#  创建临时表
SQL&gt;  create table u_logminer.dba_objects as select * from all_objects;
# 更新操作
SQL&gt; select status,owner,object_name from U_LOGMINER.dba_objects where owner = 'U_LOGMINER';

STATUS  OWNER                  OBJECT_NAME
------- ------------------------------ --------------------
INVALID U_LOGMINER             ALL_OBJECTS
INVALID U_LOGMINER             ALL_OBJECTS
INVALID U_LOGMINER             ALL_OBJECTS
INVALID U_LOGMINER             ALL_OBJECTS
 # update 更新
SQL&gt; update U_LOGMINER.dba_objects set STATUS = 'VALID' where owner = 'U_LOGMINER';

4 rows updated.

SQL&gt; commit;

Commit complete.

SQL&gt; select status,owner,object_name from U_LOGMINER.dba_objects where owner = 'U_LOGMINER';

STATUS  OWNER                  OBJECT_NAME
------- ------------------------------ --------------------
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
# insert 插入
SQL&gt; insert into U_LOGMINER.dba_objects select * from dba_objects where owner = 'U_LOGMINER';

4 rows created.

SQL&gt; commit;

Commit complete.

SQL&gt; select status,owner,object_name from U_LOGMINER.dba_objects where owner = 'U_LOGMINER';

STATUS  OWNER                  OBJECT_NAME
------- ------------------------------ --------------------
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS
VALID   U_LOGMINER             ALL_OBJECTS

8 rows selected.
# delete 删除
SQL&gt; delete from U_LOGMINER.dba_objects where owner = 'U_LOGMINER';

8 rows deleted.

SQL&gt; commit;

Commit complete.
</code></pre>
<h5>使用Logminer 分析归档日志</h5>
<pre><code># 添加日志文件进行分析，第一个文件 dbms_logmnr.NEW，后面的文件dbms_logmnr.ADDFILE
SQL&gt; BEGIN
  2  dbms_logmnr.add_logfile(logfilename=&gt;'/u01/app/oracle/fast_recovery_area/ORCL/archivelog/2017_08_19/o1_mf_1_106_dshlmn6r_.arc',options=&gt;dbms_logmnr.NEW);
  3  dbms_logmnr.add_logfile(logfilename=&gt;'/u01/app/oracle/fast_recovery_area/ORCL/archivelog/2017_08_19/o1_mf_1_107_dshlmoo2_.arc',options=&gt;dbms_logmnr.ADDFILE);
  4  dbms_logmnr.add_logfile(logfilename=&gt;'/u01/app/oracle/fast_recovery_area/ORCL/archivelog/2017_08_19/o1_mf_1_108_dshm5n1x_.arc',options=&gt;dbms_logmnr.ADDFILE);
  5  end;
  6  /

PL/SQL procedure successfully completed.
# 开始分析，当前是完整分析日志文件的内容，可以操作时间、SCN等过滤需要分析的内容
SQL&gt; EXECUTE dbms_logmnr.start_logmnr(dictfilename =&gt;'/u01/app/oracle/logminer/dictionary.ora');
# 或者
SQL&gt; EXECUTE dbms_logmnr.start_logmnr(DictFileName =&gt;'/u01/app/oracle/logminer/dictionary.ora', StartTime =&gt;to_date('2017-8-19 00:00:00','YYYY-MM-DD HH24:MI:SS'),EndTime =&gt;to_date('2017-8-19 17:00:00','YYYY-MM-DD HH24:MI:SS '));
# 或者
SQL&gt;
SQL&gt; EXECUTE dbms_logmnr.start_logmnr(DictFileName =&gt;'/u01/app/oracle/logminer/dictionary.ora', StartScn&gt;=20, EndScn&lt;= 50);

PL/SQL procedure successfully completed.
# 结果放在视图中，注意当会话结束，临时表会被删除
SQL&gt; SELECT count(*) FROM v$logmnr_contents; 

  COUNT(*)
----------
     42118
# 将临时表数据备份至物理表中
SQL&gt; create table u_logMIner.logminer_tmp as select * from  v$logmnr_contents; 

Table created.

</code></pre>
<h5>日志文件分析完成，接下来就看看对表到底做了什么操作</h5>
<pre><code># 根据事务开始时间进行排序，查询数据表的变更记录
SQL &gt; SELECT START_TIMESTAMP,COMMIT_TIMESTAMP,sql_redo,sql_undo,machine_name,os_username,username,table_name FROM u_logMIner.logminer_tmp WHERE username='U_LOGMINER' AND table_name='DBA_OBJECTS' order by START_TIMESTAMP;

# sql_redo 更改数据的SQL
# sql_undo 回滚数据的SQL
# machine_name,os_username,username 三位一体定位执行更新的机器、数据库用户名

# 如下：
SQL&gt; SELECT sql_redo FROM u_logMIner.logminer_tmp WHERE username='U_LOGMINER' AND table_name='DBA_OBJECTS' order by START_TIMESTAMP;

SQL_REDO
--------------------------------------------------------------------------------
update "U_LOGMINER"."DBA_OBJECTS" set "STATUS" = 'INVALID' where "STATUS" = 'VAL
ID' and ROWID = 'AAAD8EAAIAAAAJAAAf';

update "U_LOGMINER"."DBA_OBJECTS" set "STATUS" = 'INVALID' where "STATUS" = 'VAL
ID' and ROWID = 'AAAD8EAAIAAAAKHAAv';
…………

# 如下：
SQL&gt; SELECT sql_undo FROM u_logMIner.logminer_tmp WHERE username='U_LOGMINER' AND table_name='DBA_OBJECTS' order by START_TIMESTAMP;

SQL_UNDO
--------------------------------------------------------------------------------
update "U_LOGMINER"."DBA_OBJECTS" set "STATUS" = 'VALID' where "STATUS" = 'INVAL
ID' and ROWID = 'AAAD8EAAIAAAAJAAAf';

update "U_LOGMINER"."DBA_OBJECTS" set "STATUS" = 'VALID' where "STATUS" = 'INVAL
ID' and ROWID = 'AAAD8EAAIAAAAKHAAv';

update "U_LOGMINER"."DBA_OBJECTS" set "STATUS" = 'VALID' where "STATUS" = 'INVAL
ID' and ROWID = 'AAAD8EAAIAAAAPoAA0';
………………
</code></pre>
<h5>SQL拿出来了，就可以定位问题，但是能不能立刻回滚到生产环境，还需要和业务部门进行沟通。</h5>
<h5>建议在创建数据库时，就打开强制日志、归档模式，配置 utl_file_dir 参数，避免数据库重启对线上的影像</h5>
<h5>当然也可以直接下其他环境下的数据库做日志分析工作，有两个点需要注意：数据字典和日志文件，其他和在本机处理没什么两样。</h5>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:48:13</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/oracle/" title="oracle">oracle</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/database/" title="database">database</a>, <a href="https://www.iamivan.net/tag/%e5%9c%a8%e7%ba%bf/" title="在线">在线</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97/" title="日志">日志</a>, <a href="https://www.iamivan.net/tag/update/" title="update">update</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97%e5%88%86%e6%9e%90/" title="日志分析">日志分析</a>, <a href="https://www.iamivan.net/tag/%e5%bd%92%e6%a1%a3/" title="归档">归档</a>, <a href="https://www.iamivan.net/tag/logminer/" title="logminer">logminer</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Oracle Logminer 日志挖掘的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn0W2jb.html" rel="bookmark">Oracle日志挖掘之LogMiner</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle日志挖掘之LogMiner 官方文档地址:http://docs.oracle.com/cd/E11882_01/server.112/e22490/logminer.htm#SUTIL019 众所周知,所有对用户数据和数据字典的改变都记录在Oracle的Redo Log中,因此,Redo Log包含了所有进行恢复操作所需要的信息.但是,原始的Redo Log文件无法看懂,所以,Oracle从8i以后提供了一个非常有用的分析工具,称为LogMiner.使用该工具可以轻松获得Redo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ90AWb.html" rel="bookmark">Oracle 10g LOGMNR挖掘日志很方便</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自http://blog.zdnet.com.cn/html/80/289380-2877270.html Oracle 10g LOGMNR挖掘日志很方便 .   Oracle 10g可以使用LOGMNR在线分析和挖掘日志,使用当前在线的数据字典,非常方便. 首先执行一些DDL或DML操作: SQL&gt; connect eygle/eygleConnected. SQL&gt; alter system switch logfile; System altered. SQL&gt; create			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGJa2kp.html" rel="bookmark">使用Oracle logminer 找回delete的数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.logminer介绍 2.logminer的用法 3.帮助用户找回delete的数据 1.logminer介绍 LogMiner 是Oracle公司从产品8i以后提供的一个实际非常有用的分析工具,使用该工具可以轻松获得Oracle 重做日志文件(归档日志文件)中的具体内容,LogMiner分析工具实际上是由一组PL/SQL包和一些动态视图组成,它作为Oracle数据库的一部分来发布,是oracle公司提供的一个完全免费的工具. 2.logminer的用法 在用logminer获取数据字典文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrqwZWb.html" rel="bookmark">Oracle 归档日志</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--==================== -- Oracle 归档日志 --====================       Oracle可以将联机日志文件保存到多个不同的位置,将联机日志转换为归档日志的过程称之为归档.相应的日志被称为归档日志.   一.归档日志     是联机重做日志组文件的一个副本     包含redo记录以及一个唯一的log sequence number     对日志组中的一个日志文件进行归档,如果该组其中一个损坏,则另一个可用的日志将会被归档     对于归			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEE7WJb.html" rel="bookmark">Oracle LogMiner</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle LogMiner 是Oracle公司从产品8i以后提供的一个实际非常有用的分析工具,使用该工具可以轻松获得Oracle 重作日志文件(归档日志文件)中的具体内容,特别是,该工具可以分析出所有对于数据库操作的DML(insert.update.delete等)语句,另外还可分析得到一些必要的回滚SQL语句.该工具特别适用于调试.审计或者回退某个特定的事务. LogMiner分析工具实际上是由一组PL/SQL包和一些动态视图(Oracle8i内置包的一部分)组成,它作为Oracle数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp8WBMg.html" rel="bookmark">web日志中的频繁访问日志挖掘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web访问日志 主要是指用户在访问某网站的时候产生的日志信息,采集方式包括前端Javascript埋码采集和后端服务器日志采集两种. 前端采集目前主要以javascript为主,收集用户数据. 后端服务器日志根据网站架构,一般以nginx和tomcat等加上业务日志的采集为主. 对于数据的权威和准确性而言,应该首先以后端服务器产生的数据为主,配合前端采集的数据来进行整体的分析和挖掘. 日志分析流程 日志分析流程如下: 数据采集:包括埋码和业务数据收集两种. 数据传输:包括实时和离线传输两种. 存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQPL9Oz.html" rel="bookmark">Oracle重做日志文件管理技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重做日志文件是Oracle数据库中一种非常重要的日志文件,也是其一个很有特色的功能.重做日志文件会纪录对于数据库的任何操作,如利用DML语句或者DDL语句对数据进行更改,或者数据库管理员对数据库结构进行更改,都会在重做日志中进行记录. 可见,当数据被意外的删除或者修改,我们可以利用重新日志文件进行恢复; 当出现例程失败或者介质失败的情况下,也可以利用日志文件实现例程恢复或者介质恢复.所以说,我们若能够管理好重做日志文件的话,对于保障数据库数据的安全是非常重要的. 下面笔者谈谈管理好Oracle			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQNAWwM.html" rel="bookmark">跟我一起数据挖掘（20）&mdash;&mdash;网站日志挖掘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				收集web日志的目的 Web日志挖掘是指采用数据挖掘技术,对站点用户访问Web服务器过程中产生的日志数据进行分析处理,从而发现Web用户的访问模式和兴趣爱好等,这些信息对站点建设潜在有用的可理解的未知信息和知识,用于分析站点的被访问情况,辅助站点管理和决策支持等. 1.以改进web站点设计为目标,通过挖掘用户聚类和用户的频繁访问路径,修改站点的页面之间的链接关系,以适应用户的访问习惯,并且同时为用户提供有针对性的电子商务活动和个性化的信息服务,应用信息推拉技术构建智能化Web站点. 2.以分析W			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NyVyM.html" rel="bookmark">查看oracle归档日志路径1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				查看oracle归档日志路径 1.修改归档日志的格式 默认格式是:&quot; %t_%s_%r.dbf&quot;,我们尝试将格式修改为&quot;%t_%s_%r.arch&quot;,这是一个静态参数,需要重新启动数据库才生效.sys@ora10g&gt; show parameter log_archive_format NAME                  TYPE        VALUE--------------------- ----------- ----------------			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLOa0M.html" rel="bookmark" class="title">wpf dispatcher&period;begininvoke与匹配的重载方法具有一些无效参数</a>
					<div>
						问题描述 wpf dispatcher.begininvoke与匹配的重载方法具有一些无效参数 wpf dispatcher.begininvoke与匹配的重载方法具有一些无效参数,我在另外一个项目里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2Lo4p.html" rel="bookmark" class="title">图标设计简单的教程&colon;蜕变你普通的图标</a>
					<div>
						文章描述:今天刚好有些时间,所以抽空写了这个简单的教程,希望对大家有所帮助,步骤不是很详细,有看不懂的可以在线提问,我会尽量回答,要是你愿意的话,记得教个作业哦! 天刚好有些时间,所以抽空写了这个简单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnrA2p.html" rel="bookmark" class="title">在Dreamweaver中巧用框架建立网站</a>
					<div>
						dreamweaver 本文选自4u2v工作室编写的&lt;Dreamweaver网页设计与制作100例&gt;(人民邮电出版社出版,ISBN: 7115142394).未经著作权所有者书面授权许可, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz47Grp.html" rel="bookmark" class="title">一个连接池的例子（说明）</a>
					<div>
						这个连接池是直接从JIVE中取出来的,进行了一下修改,使得连接参数直接在程序中设定而不是从属性文件中读取. 用法:先设定自己的连接参数,在DbConnectionDefaultPool.java文件的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGyDeM.html" rel="bookmark" class="title">亲密接触ADO&period;NET v2&period;0</a>
					<div>
						ado 随Whidbey发布的新一代ADO.NET有一些伟大的特征,这将使我们开发人员的生活变得更轻松一点点.下面我向大家介绍ADO.NETv2.0的一些特征. 一．多活动结果集(MARS:Multi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXGyKM.html" rel="bookmark" class="title">php类的析构方法</a>
					<div>
						析构方法主要是用于释放资源,比如释放数据库连接或者图片资源,或者销毁某个对象. 1.析构方法会被自动调用 2.析构方法主要是用于释放资源 3.析构方法调用顺序是:先创建的对象,后被销毁. 4.析构方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PQajM.html" rel="bookmark" class="title">Cisco策略路由&lpar;policy route&rpar;精解</a>
					<div>
						注:PBR以前是CISCO用来丢弃报文的一个主要手段.比如:设置set interface null 0,按CISCO说法这样会比ACL的deny要节省一些开销.这里我提醒: interface nu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4LVjp.html" rel="bookmark" class="title">让你的软件界面更漂亮（五）</a>
					<div>
						类WindowXp 开始菜单到现在基本上是完美实现,在功能上基本和WindowXp 与Vista 操作系统的开始菜单一样,界面当然漂亮,通过编程能实现风格多样,具有个性化的功能菜单.为了方便使用,本人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6P7Xz.html" rel="bookmark" class="title">透明浏览器窗口的实现</a>
					<div>
						首先先看一下效果图: 本实现是基于WPF,VS版本2008 SP1. 先说一下在Winform中的实现方法:很简单通过设置窗体的opacity来实现,或者还可以设置TransparentKey来实现某 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKxgEM.html" rel="bookmark" class="title">PowerPoint如何巧用动作路径自定义动画</a>
					<div>
						  一.使用已有的动作路径 PowerPoint2003本身共有三大类64种软件自带的动作路径,我们可以直接使用这些动作路径. 运行PowerPoint2003后,单击&quot;插入/新幻灯片&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E9EdM.html" rel="bookmark" class="title">为word文档自动添加摘要的操作步骤</a>
					<div>
						  点击word文档左上角的office按钮,在下拉菜单中选择右下角的&quot;word选项&quot; 在弹出的&quot;word选项&quot;对话框中,点击左边的&quot;自定义&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjNdjb.html" rel="bookmark" class="title">Win7电脑系统崩溃如何解决</a>
					<div>
						  解决方法如下: 1.当电脑出现系统崩溃的情况时,我们可以在重新启动电脑的时候,找到相关的修复方案. 2.在启动的过程中找到启动修复的功能按钮,然后对我们的电脑系统进行修复,来完成修复系统崩溃. 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBZ0nz.html" rel="bookmark" class="title">彩视好用吗？</a>
					<div>
						  彩视好用吗? 彩视生活,视频分享!彩视可以将您的靓照以各种视频特效,加上您喜欢的音乐歌曲,配上您自创的文字或录音旁白,非常方便地制作成视频短片,供您与朋友在各个社交媒体分享或自己收藏. 新版彩视a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqyGxb.html" rel="bookmark" class="title">mysql外键约束使用详解</a>
					<div>
						MySQL有两种常用的引擎类型:MyISAM和InnoDB.目前只有InnoDB引擎类型支持外键约束.InnoDB中外键约束定义的语法如下: [CONSTRAINT [symbol]] FOREIGN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX02Oz.html" rel="bookmark" class="title">javascript-必应地图怎么通过js定位所在城市</a>
					<div>
						问题描述 必应地图怎么通过js定位所在城市 必应地图是微软的一款地图,我现在需要通过js实现定位所在城市功能 解决方案 http://www.cnblogs.com/milkmap/p/3834039 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR0kYp.html" rel="bookmark" class="title">struct-数组赋值和结构体中的数组赋值问题</a>
					<div>
						问题描述 数组赋值和结构体中的数组赋值问题 typedef struct _Teacher{ char name[20]; int age; }Teacher; void main(){ Teache ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXj01z.html" rel="bookmark" class="title">5款App帮助检测你的带宽</a>
					<div>
						互联网测速应用出现已经有段时间了.我们大多数人都或多或少地使用过SpeedTest.net.SpeakEasy.net/SpeedTest或者我们ISP的速度测试站点来检测我们的带宽.不过,这些应用大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRv1Ab.html" rel="bookmark" class="title">网页抓取工具之数据预处理</a>
					<div>
						提取的数据还不能直接拿来用?文件还没有被下载?格式等都还不符合要求?别着急,网页抓取工具火车采集器自有应对方案--数据处理. 图片1.png 网页抓取工具的数据处理功能包括三个部分,分别是内容处理.文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnjVdM.html" rel="bookmark" class="title">网络要上天！ 雄心勃勃的天空网络计划</a>
					<div>
						&quot;你咋不上天呢!&quot;是近期社交网络上非常流行的一句话,表达了一种讽刺的意味.但是,现在我们的身边,真的有要上天的事物了!无线网络要上天,您敢相信么?为什么要这么说呢?这是因为,科技界 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgV09M.html" rel="bookmark" class="title">《中国人工智能学会通讯》&mdash;&mdash;11&period;25 单目视频下运动物体建模及分析</a>
					<div>
						11.25 单目视频下运动物体建模及分析 特征点轨迹是刻画视频中不同图像帧匹配关系的一种常用表示,其首先提取图像中的特征点,例如Harris 特征点,然后利用 Lucas-Kanade 方法[3]对这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRe0jp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;御天敌&rdquo;将在《变形金刚3》中出场&lpar;图&rpar;</a>
					<div>
						&quot;御天敌&quot;在动画版中的形象 新浪娱乐讯 北京时间2月11日消息,据国外媒体报道,迈克尔·贝(Michael Bay)最近接受MTV采访时,证实了擎天柱的前任&quot;御天敌&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNE58M.html" rel="bookmark" class="title">求助关于powerdesiger</a>
					<div>
						问题描述 求助关于powerdesiger 我安装好的powerdesiger,点file以后,再点newmodel,可是newmodel是灰色不可用的状态,是怎么回事啊?是我下载错了还是安装错了?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj82YWp.html" rel="bookmark" class="title">Java数据排序几种算法&lpar;堆排序  插入排序 快速排序&rpar;</a>
					<div>
						堆排序算法 核心思想:用数组来表示完全二叉树,然后逐步把这个二叉树由半堆变成堆.经过不断转化,整个二叉树的根节点的值必然是最大的,然后把这个最大值放到二叉树最后的(数组的最后).以后再进行堆化的过程时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYZeob.html" rel="bookmark" class="title">PHP中ASCII码对照表与字符转换详解</a>
					<div>
						通用的ASCII码对照表 图解ASCII码对照表图,以字符A为例 Dec表示十进制,如65 Hx表示十六进制,如41 Oct表示八进制,如101 Char表示显示字符,如A ASCII码对照表图分为两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmgeVp.html" rel="bookmark" class="title">php 获取当前页面地址</a>
					<div>
						基于函数了解 PHP实现:  代码如下 复制代码 //获取域名或主机地址 echo $_SERVER['HTTP_HOST'].&quot;&lt;br&gt;&quot;; #localhost / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW709mM.html" rel="bookmark" class="title">Android 如何获取手机总内存和可用内存等信息&lowbar;Android</a>
					<div>
						在android开发中,有时候我们想获取手机的一些硬件信息,比如android手机的总内存和可用内存大小. 这个该如何实现呢? 通过读取文件&quot;/proc/meminfo&quot;的信息能够 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOJmDb.html" rel="bookmark" class="title">类似&lpar;安居客、淘宝网&rpar;&comma;查询条件用链接，页面元素重新加载问题</a>
					<div>
						问题描述 真诚向各位请教一个问题,我找了两天,也没有解决方案:asp.net,网站,为了seo优化,每个查询条件都是一个a标签链接,安居客.淘宝网,都是这样实现的,如:../suzhou/listst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWPyZM.html" rel="bookmark" class="title">关于同某物流网合作计划书</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 共同的目标:把XX物流网打造为西北 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2gQGz.html" rel="bookmark" class="title">Linux CentOS PXE&plus;Kickstart</a>
					<div>
						PXE+Kickstart安装条件和步骤 首先,大家如果看到有什么不懂的地方,欢迎吐槽!!! 我会在当天或者第二天及时回复,并且改进~~ 安装条件 DHCP Server TFTP Server Ki ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6YOJNb.html" rel="bookmark" class="title">rails 中怎么设置图片的验证码？有没有插件？</a>
					<div>
						问题描述 rails 中怎么设置图片的验证码?有没有插件?这个是怎么实现的呢? 解决方案 http://hideto.iteye.com/blog/199757讲的就是这个呢					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
